<template>
  <div class="box-main">
    <MomTable
      ref="MomTable"
      row-key="id"
      :row-selection="rowSelection"
      :columns="tableColumns"
      :data-source="tableData"
      :query-param="queryForm"
      :query-param-item="queryFormItem"
      :total="total"
      :page.sync="page"
      :action-buttons="actionButtons"
      :show-enable-flag="true"
      @edit="handleEdit"
      @delete="handleDelete"
      @search="searchPageData"
      @enable="
        (record) =>
          handleStatus(
            { status: 'Y', id: record.id },
            'ENABLED',
            'ENABLED_DATA_INFO',
            'ENABLE_SUCCESS'
          )
      "
      @disable="
        (record) =>
          handleStatus(
            { status: 'N', id: record.id },
            'DISABLED',
            'DISABLED_DATA_INFO',
            'DISABLE_SUCCESS'
          )
      "
    >
      <div slot="toolbar" class="button-top-table">
        <a-button
          v-if="hasAuth('USER_GROUP_MANAGEMENT:ADD')"
          type="primary"
          @click="handleAdd"
        >
          <a-icon type="plus" /> {{ $t("ADD") }}
        </a-button>
        <a-button
          v-if="hasAuth('USER_GROUP_MANAGEMENT:BATCH_DELETE')"
          type="danger"
          icon="delete"
          @click="handDelete"
        >
          {{ $t("BATCH_DELETE") }}
        </a-button>
      </div>
      <template slot="enableFlag" slot-scope="text">
        <span :class="text === 'Y' ? 'text-success' : 'text-error'">
          {{ getAttrValue(statusList, text) }}
        </span>
      </template>
    </MomTable>
    <MegaDrawer
      :visible="drawerVisible"
      :title="form.id ? $t('EDIT') : $t('ADD')"
      append-to-body
      width="520"
      @close="handleCloseDrawer"
    >
      <template slot="main">
        <a-form-model
          ref="addForm"
          layout="vertical"
          :model="form"
          :rules="rules"
        >
          <a-row>
            <a-col :span="24">
              <a-form-model-item
                :label="$t('USER_GROUP_CODE')"
                prop="groupCode"
              >
                <a-input v-model="form.groupCode" :disabled="form.id !== ''" />
              </a-form-model-item>
            </a-col>
            <a-col :span="24">
              <a-form-model-item
                :label="$t('USER_GROUP_NAME')"
                prop="groupName"
              >
                <a-input v-model="form.groupName" :disabled="form.id !== ''" />
              </a-form-model-item>
            </a-col>
            <a-col :span="24">
              <a-form-model-item :label="$t('DESCRIBE')" prop="remark">
                <a-input v-model="form.remark" type="textarea" />
              </a-form-model-item>
            </a-col>
          </a-row>
        </a-form-model>
        <MomTable
          ref="MomTableDrawer"
          row-key="userName"
          :columns="tableColumnsDrawer"
          :data-source="tableDataDrawer"
          :total="totalDrawer"
          :pagination="false"
          :action-buttons="actionButtonsItem"
          @delete="handleDeleteItem"
        >
          <div slot="toolbar" class="button-top-table">
            <!-- <a-button type="primary" @click="handleAddItem">
              {{ $t("ADD") }}
            </a-button> -->
            <SelectUser
              ref="selectUser"
              :show-clear="false"
              :default-selected-keys="selectUserList"
              @confirm="getReturnData"
            >
              <div class="button-top-table">
                <a-button type="primary">
                  {{ $t("ADD") }}
                </a-button>
              </div>
            </SelectUser>
          </div>
        </MomTable>
      </template>
      <footer slot="footer">
        <a-button type="primary" @click="handleSave()">
          <Icon type="icon-cur-save_1" :size="18" />{{ $t("SAVE") }}
        </a-button>
        <a-button @click="handleCloseDrawer">
          <Icon type="icon-dir-f-rollback" :size="18" />{{ $t("CANCEL") }}
        </a-button>
      </footer>
    </MegaDrawer>
  </div>
</template>
<script>
import { Drawer as MegaDrawer, Icon } from "@mega-design/ui-vue";
import ApiConstant from "@/api/ApiConstant";
import SelectUser from "@/components/SelectUser";

export default {
  components: { SelectUser, MegaDrawer, Icon },
  data() {
    const validatePass = (rule, value, callback) => {
      if (value === "") {
        callback(new Error(this.$t("COMPANY_CREDIT_CODE")));
      } else if (this.form.creditCode !== "") {
        const patrn = /^[0-9A-Z]+$/;
        if (
          patrn.test(this.form.creditCode) === false ||
          this.form.creditCode.length !== 18
        ) {
          callback(new Error(this.$t("COMPANY_CREDIT_CODE")));
        } else {
          callback();
        }
      }
    };
    return {
      title: "", // 弹框标题
      drawerVisible: false, // 新增修改的弹框
      drawerVisibleView: false, // 查看弹框
      // 查询sort
      tableData: [], // 表格数据
      page: 1, // 分页第几页
      total: 0, // 数据表格总条数
      tableDataDrawer: [],
      form: {
        id: "",
        groupCode: "",
        groupName: "",
        userNames: [],
        remark: "",
      },
      rules: {
        groupName: [
          {
            required: true,
            message: this.$t("PLACEENTER"),
            trigger: "blur",
          },
        ],
      },
      rulesConfig: {
        propertyCode: [
          {
            required: true,
            message: this.$t("PLACEENTER"),
            trigger: "blur",
          },
        ],
        propertyValue: [
          {
            required: true,
            message: this.$t("PLACEENTER"),
            trigger: "blur",
          },
        ],
      },
      groupTypeList: [], // 类型列表
      statusList: [], // 状态列表
      // 查询的表单的配置项
      queryForm: {
        groupCode: "",
        groupName: "",
      },
      actionButtons: [
        this.hasAuth("USER_GROUP_MANAGEMENT:EDIT") && "edit",
        this.hasAuth("USER_GROUP_MANAGEMENT:DELETE") && "delete",
      ],
      actionButtonsItem: ["delete"],
      selectUserList: [], // 当前所有的用户列表
      totalDrawer: 0,
      selectedRowKeys: [],
    };
  },
  computed: {
    rowSelection() {
      return {
        selectedRowKeys: this.selectedRowKeys,
        onChange: (selectedRowKeys, selectedRows) => {
          this.selectedRowKeys = selectedRowKeys;
        },
      };
    },
    queryFormItem() {
      return this.$observable("queryFormItem", {
        groupCode: {
          label: () => this.$t("USER_GROUP_CODE"),
        },
        groupName: {
          label: () => this.$t("USER_GROUP_NAME"),
        },
      });
    },
    tableColumns() {
      return [
        {
          dataIndex: "groupCode",
          sorter: false,
          title: this.$t("USER_GROUP_CODE"),
          minWidth: 200,
        },
        {
          dataIndex: "groupName",
          title: this.$t("USER_GROUP_NAME"),
          minWidth: 200,
        },
        {
          dataIndex: "enableFlag",
          sorter: false,
          title: () => this.$t("STATUS"),
          scopedSlots: { customRender: "enableFlag" },
          width: 120,
        },
        // 更新人员
        {
          dataIndex: "updateBy",
          sorter: false,
          title: this.$t("UPDATE_BY"),
          width: 210,
        },
        // 更新时间
        {
          dataIndex: "updateTime",
          sorter: false,
          title: this.$t("UPDATE_TIME"),
          width: 210,
        },
      ];
    },
    tableColumnsDrawer() {
      return [
        {
          sorter: false, // 隐藏排序
          dataIndex: "userName",
          title: this.$t("USER_NAME"),
          minWidth: 210,
        },
      ];
    },
  },
  mounted() {
    this.queryDictData();
  },
  methods: {
    queryDictData() {
      return Promise.all([
        this.getDictByCode(`DIC:COMMON:ENABLE_FLAG`), // 启用状态
        this.getDictByCode(`DIC:MSG:RECEIVE_GROUP_TYPE`), // 服务类型
      ]).then(([enableStatusRes, groupTypeRes]) => {
        this.statusList = enableStatusRes.data.data;
        this.groupTypeList = groupTypeRes.data.data;
      });
    },
    formatData(data, curItem) {
      const result = data.find((item) => item.value === curItem);
      return result ? result.label : "";
    },
    searchPageData(params) {
      this.$axios
        .get(`${ApiConstant.PREFIX_CORE}/api/msg/user-group/search`, { params })
        .then((res) => {
          this.tableData = res.data.data.records;
          this.total = parseFloat(res.data.data.total);
        });
    },
    // 新增按钮的点击
    handleAdd() {
      this.clearData();
      this.$set(this, "form", {
        id: "",
        groupCode: "",
        groupName: "",
        groupType: "",
        remark: "",
      });
      this.drawerVisible = true;
    },
    // 编辑按钮点击
    handleEdit(row) {
      this.clearData();
      this.$axios
        .get(
          `${ApiConstant.PREFIX_CORE}/api/msg/user-group/get-by-id/${row.id}`
        )
        .then((res) => {
          this.form = { ...res?.data?.data };
          const userNames = res?.data?.data?.itemList || [];
          if (userNames.length > 0) {
            let tempObj;
            userNames.forEach((item) => {
              tempObj = {
                userName: item.userName,
                id: item.id,
              };
              this.tableDataDrawer.push(tempObj);
              this.selectUserList.push(item.userName);
            });
            this.totalDrawer = userNames.length;
          }

          this.drawerVisible = true;
        });
    },
    // 监听点击保存事件
    handleSave() {
      this.$refs.addForm.validate((valid) => {
        if (valid) {
          this.form.userNames = [];
          if (this.tableDataDrawer.length > 0) {
            this.tableDataDrawer.forEach((item) => {
              this.form.userNames.push({
                id: item.id,
                userName: item.userName,
              });
            });
          }
          const req = {
            ...this.form,
          };
          if (!this.form?.id) {
            this.$axios
              .post(`${ApiConstant.PREFIX_CORE}/api/msg/user-group`, req)
              .then((res) => {
                this.$message.success(this.$t("ADD_SUCCESS"));
                this.$refs.MomTable?.query();
                this.drawerVisible = false;
              });
          } else {
            this.$axios
              .put(`${ApiConstant.PREFIX_CORE}/api/msg/user-group`, req)
              .then((res) => {
                this.$message.success(this.$t("EDIT_SUCCESS"));
                this.$refs.MomTable?.query();
                this.drawerVisible = false;
              });
          }
        }
      });
    },
    handDelete() {
      if (this.selectedRowKeys.length > 0) {
        this.$confirm({
          title: this.$t("DELETE"),
          content: this.$t("DELETE_INFO"),
          okType: "warning",
          okText: this.$t("CONFIRM"),
          cancelText: this.$t("CANCEL"),
          centered: false,
          icon: "close-circle",
          onOk: () => {
            this.$axios
              .delete(
                `${ApiConstant.PREFIX_CORE}/api/msg/user-group/batch-delete`,
                {
                  params: {
                    ids: this.selectedRowKeys.join(","),
                  },
                }
              )
              .then((res) => {
                this.$message.success(this.$t("DELETE_SUCCESS"));
                this.$refs.MomTable?.query();
              });
          },
        });
      } else {
        this.$message.error(this.$t("SELECT_ONE_DATA"));
      }
    },
    // 点击表格行内的删除
    handleDelete(row) {
      this.$confirm({
        title: this.$t("DELETE"),
        content: this.$t("DELETE_INFO"),
        okType: "warning",
        okText: this.$t("CONFIRM"),
        cancelText: this.$t("CANCEL"),
        centered: false,
        icon: "close-circle",
        onOk: () => {
          this.$axios
            .delete(`${ApiConstant.PREFIX_CORE}/api/msg/user-group/${row.id}`)
            .then((res) => {
              this.$message.success(this.$t("DELETE_SUCCESS"));
              this.$refs.MomTable?.query();
            });
        },
      });
    },
    // 关闭弹框
    handleCloseDrawer() {
      this.$refs.addForm.clearValidate();
      this.drawerVisible = false;
    },
    // 获取选择用户组件返回数据
    getReturnData(selectedRowKeys, selectedRows) {
      // eslint-disable-next-line no-multi-assign
      this.tableDataDrawer = this.selectUserList = [];
      if (selectedRowKeys.length > 0) {
        this.selectUserList = selectedRowKeys || [];
        if (selectedRows && selectedRows.length > 0) {
          let tempObj;
          this.tableDataDrawer = selectedRows.map((item) => {
            tempObj = {
              id: item.id ? item.id : item.groupCode,
              userName: item.userName ? item.userName : item.groupName,
            };
            return tempObj;
          });
        }
      }
    },
    // 删除详情
    handleDeleteItem(row) {
      this.$confirm({
        title: this.$t("DELETE"),
        content: this.$t("DELETE_INFO"),
        okType: "warning",
        okText: this.$t("CONFIRM"),
        cancelText: this.$t("CANCEL"),
        centered: false,
        icon: "close-circle",
        onOk: () => {
          const index = this.tableDataDrawer.findIndex(
            (item) => item.userName === row.userName
          );
          this.tableDataDrawer.splice(index, 1);
          const indexSelect = this.selectUserList.findIndex(
            (item) => item === row.userName
          );
          this.selectUserList.splice(indexSelect, 1);
        },
      });
    },
    // 启用、禁用
    handleStatus(record, titleText, contentText, tips) {
      this.$confirm({
        title: this.$t(titleText),
        content: this.$t(contentText),
        okText: this.$t("CONFIRM"),
        cancelText: this.$t("CANCEL"),
        centered: false,
        icon: "exclamation-circle",
        onOk: () => {
          const { id, status } = record;
          this.$axios
            .put(
              `${ApiConstant.PREFIX_CORE}/api/msg/user-group/enable/${id}/${status}`
            )
            .then((res) => {
              this.$message.success(this.$t(tips));
              this.$refs.MomTable?.query();
            });
        },
      });
    },
    // 清除数据
    clearData() {
      this.selectUserList = [];
      this.tableDataDrawer = [];
    },
  },
};
</script>
<style lang="scss" scoped>
/deep/ .mega-design-drawer__footer {
  border-top: none;
  button:last-child {
    margin-left: 10px;
    i {
      margin-right: 5px;
    }
  }
}
</style>
